/**************************************************************************
 *
 *   Program          :  vect_fun.h
 *   Purpose          :  Header file includes vector functions.
 *   Programmer       :  Umesh S. Shisode
 *   Created on       :  14-01-2015
 *   Last Modified    :  Wednesday 14 January 2015 06:24:40 PM IST
 *
 **************************************************************************/
# include <iostream>
# include <fstream>
#include<cmath>
#include<iomanip>
#include<cstdlib>

using namespace std;
template<class T>
class Vector{
	//	int nrows;
	//	float *vect;

	public:
		int nrows;
		T *vect;//[4];
		Vector();
		Vector(int m);

		void read(string filename);
		//    float norm();
		void print();

		//------------------------------------------OPERATOR-OVERLOADING---------------------------------------------------------------------------------------------------------
		T operator()(const int);
		int get_row();
		void put(int i, T value);
		T get(int i);
		T* getVect();
};

//--------------------------------------------------------VECTOR-CONSTRUCTORS--------------------------------------------------------------------------------------------

template<class T>
T* Vector<T>::getVect(){
	return vect;
}

	template<class T>
Vector<T>::Vector()
{
	nrows=0;
	vect=NULL;
}

	template<class T>
Vector<T>::Vector(int m)
{
	nrows=m;
	double temp[nrows];

	vect=temp;//new T[nrows];

	for(int i=0;i<nrows;++i)
	{
		vect[i]=rand() % 10;
	}
}

//------------Vector-READING----------------------------------------------------

	template<class T>
void Vector<T>::read(string filename)
{
	ifstream rfile;
	rfile.open(filename.c_str());
	rfile>>nrows;

	//double temp[nrows];
	vect=new T[nrows];

	for(int i=0;i<nrows;++i)
	{
		rfile>>vect[i];
	//		rfile>>temp[i];
	}
	//for (int i=0; i<nrows; i++)
	//	cout << "temp[" << i << "]  = " << temp[i] << endl;
//	vect = temp;
	print();
	rfile.close();
}

//------------Vector-PRINT-----------------------------------------------------

	template<class T>
void Vector<T>::print()
{
	//cout<<nrows<<endl<<ncols;
	for(int i=0;i<nrows;i++)
	{
		cout << setw(9) << fixed << vect[i];
		if (i == nrows-1)	cout << endl;
		else	cout << ", ";
	}
}

//------------Vector-PUT-&-GET-------------------------------------------------
	template<class T>
void Vector<T>::put(int i, T value)
{
	vect[i]=value;
}

	template<class T>
T Vector<T>::get(int i)
{
	T value;
	value = vect[i];
	return value;
}
